#!/usr/bin/perl

use Net::FTP;
use Cwd;

$tot_num_files = 0;
$tot_files_done = 0;

$whoami = `id -u`;
$whoami =~ s/\n//;
$nombre = "$whoami" . "_eip.log";

$log_file = "/tmp/$nombre";

$start_file = "/tmp/$whoami" . "_start.txt";
$finish_file = "/tmp/$whoami" . "_finish.txt";

$log_time = time;

$host = $ARGV[0];
$name = $ARGV[1];
$password = $ARGV[2];
$localdir = $ARGV[3];
$remotedir = $ARGV[4];
$command = $ARGV[5];
$option = $ARGV[6];

$skipped_files = "0";
$uploaed_files = "0";

$localdir =~ s/"//gi; # "
# $localdir =~ s/'//gi; # '

$httpstring = "http://";
$ftpstring = "ftp://";

$host =~ s/$httpstring//;
$host =~ s/$ftpstring//;

$todays_date = `date`;
$todays_date =~ s/\n//;

	$errmsg = "";
	$save_local = "";

&writeLog("--------------------------------------------------");
&writeLog("Welcome to Easy iWeb Publisher - v1.5");
&writeLog("by Scott Finney - Plyxim - http://www.plyxim.com/");
&writeLog("--------------------------------------------------");
&writeLog("Start Time: $todays_date");

if ($command eq "checkconfig") {

&writeLog("Checking configuration for ftp://$host");

unlink $start_file;
unlink $finish_file;

$ftp = Net::FTP->new($host,Timeout=>15) or $errmsg = "Connection failure. Cannot contact ftp://$host";
if ($errmsg eq ""){  $ftp->login($name, $password) or $errmsg = "Login failure. Check username and password."; }
if ($errmsg eq ""){  $ftp->cwd("$remotedir") or $errmsg = "Remote directory $remotedir does not exist."; }
# if ($errmsg eq ""){  $ftp->put("folder.tiff") or $errmsg = "Check Firewall Settings."; } # maybe fix this in 1.3.5 to check firewall settings
if ($errmsg eq "") { print"OK"; &writeLog("Configuration is OK.\n"); }
else { print"$errmsg"; &writeLog("Error: $errmsg"); }

exit();
}

$ftp = Net::FTP->new($host) or $errmsg = "Connection failure. Cannot contact ftp://$host";
$ftp->pasv(); # returns in version 1.3.4 to aid with firewalls
 
if ($errmsg eq "") { $ftp->login($name, $password) or $errmsg = "Login failure."; }
if ($errmsg eq "") { 
	
	&writeLog("Connected to ftp://$host"); 
	&writeLog("Local File or Folder: $localdir"); 
	&writeLog("Remote Directory: $remotedir"); 
	$ftp->binary;
	# &writeLog("Transfer type set to Binary"); 
	&writeLog("--------------------------------------------------");
	}

if ($command eq "uploadfile") {	 

	$remachar= substr($localdir,-1,1); if ($remachar eq "/") { chop($localdir); }

	until ($remchar eq "/") { $remchar= substr($localdir,-1,1); chop($localdir); $filename = $remchar . $filename; }
	$realfilename = substr($filename,1); 
	chdir($localdir) or $errmsg = "Cannot find local directory.";
	$ftp->cwd("$remotedir") or $errmsg = "Cannot find remote directory:\n$remotedir";
	&writeLog("Remote Directory Changed to $remotedir");

	$filesize = $ftp->size($realfilename);
	my ($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $locsize, $atime, $mtime, $ctime, $blksize, $blocks) = stat($realfilename);

		$verb = "";
		$complete_dir = $host . "/" . $remotedir;
		if ($option eq "dontoverwrite") { if ($filesize eq "") {	$ftp->put($realfilename);	$verb = "Uploaded"; }	}
		if ($option eq "overwrite") {	$ftp->put($realfilename);	$verb = "Uploaded"; }
		if ($option eq "onlychanged") {	if ($filesize ne $locsize) {	$ftp->put($realfilename); $verb = "Uploaded"; 	}
			else { $verb = "skipped"; }	}

		$skipped_files++ if ($verb eq "Skipped");
		$uploaded_files++ if ($verb eq "Uploaded");

		&writeLog("  $verb: $realfilename"); 

$ftp->quit;
if ($errmsg eq "") { print"File Upload Successful!";  &writeLog("File Upload Successful!"); &writeLog("$uploaded_files file(s) Uploaded, $skipped_files file(s) Skipped."); }
else { print"$errmsg"; &writeLog("$errmsg");  }
exit();

	}

if ($command eq "upload") {

$save_remote = $localdir;

# Go to the starting point in the local tree.
chdir("$localdir") or $errmsg = "Cannot find local directory ($localdir).";  # HERE

# Go to the starting point in the remote tree.
$ftp->cwd("$remotedir") or $errmsg = "Cannot find remote directory ($remotedir)."; 
&writeLog("Remote Directory Changed to $remotedir");

# Keep track of directory path as separate elements to 
# facilitate mirroring of directory paths on remote system.
my @path;

$doit="no";
finddepth_gl(\&process_item, 1);    # Map local directory tree
$doit="yes";

			open (LOG, ">$start_file") || die print"Error writing to start file!";
			print LOG "$tot_num_files";
			close (LOG);

finddepth_gl(\&process_item, 1);    # Map local directory tree

$ftp->quit;

$m_num = "No";
$m_num = $uploaded_files if ($uploaded_files != "0");

if ($errmsg eq "") { print"Folder Upload Successful!"; &writeLog("Folder Upload Successful!");  &writeLog("$m_num file(s) Uploaded, $skipped_files file(s) Skipped."); }
else { print"$errmsg"; &writeLog("$errmsg"); }

	$todays_date = `date`;
	$todays_date =~ s/\n//;
	&writeLog("End Time: $todays_date");
	&writeLog("--------------------------------------------------\n");
	
#	`chmod 777 $log_file`;
#	`chmod 777 $start_file`;
	`chmod 777 $finish_file`;

if ($errmsg eq "") {

# unlink $start_file;
# unlink $finish_file;

}

exit();

}

else { print"A connection error occured."; }


sub process_item {

	if ($doit eq "yes") {

	my ($level, $isdir, $item, $parent) = @_;
    foreach (1..$level) { #print "   " 
						}
	
	$filesize="";
	
    if ($isdir) {	my $rdtc = $parent.$item; $ftp->mkdir($rdtc); &writeLog("Directory Created: $remotedir/$rdtc/");} 
	else {
	
        my $save_remote = $ftp->pwd;
		
		if ($last_used_dir eq $parent) { }
		
		if ($parent ne "") { $ftp->cwd("$parent"); } # or $errmsg = "Cannot change remote directory ($parent) [0003].";  } ## changed in 1.2.1
		if (($errmsg eq "") and ($parent ne "")) { 
			# &writeLog("==-->Remote Directory Changed to $parent");
			}
				
			$filesize = $ftp->size($item);
			my ($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $locsize, $atime, $mtime, $ctime, $blksize, $blocks) = stat($item);

		$verb = "";
		$complete_dir = $host . "/$remotedir/" . $parent;
							
		if ($option eq "dontoverwrite") { if ($filesize eq "") {	$ftp->put($item); $verb = "Uploaded"; 	}	}
		if ($option eq "overwrite") {	$ftp->put($item); $verb = "Uploaded"; 	}
		if ($option eq "onlychanged") {	if ($filesize ne $locsize) {	$ftp->put($item); $verb = "Uploaded"; 	}
			else { $verb = "Skipped"; }	}

		if ($item =~ m/DS_Store/) { }
		else {
		$skipped_files++ if ($verb eq "Skipped");
		$uploaded_files++ if ($verb eq "Uploaded");
		
		$tot_files_done++;
		
		$status_percentage = int(($tot_files_done/$tot_num_files)*200); # $tot_num_files $tot_files_done
		
		open (LOG, ">$finish_file") || die print"Error writing to finish file!";
		print LOG "$status_percentage";
		close (LOG);

		}

		&writeLog("  $verb: $complete_dir$item"); 
	
			if (($last_used_dir ne $parent) and ($verb ne "") and ($save_remote ne "")) {							# 1.1.2 test
				$ftp->cwd("$save_remote") or $errmsg = "Cannot change remote directory ($save_remote) [cwd_s_r].";
			# 	&writeLog("Directory Changed to $save_remote");
			}

	
	}
					
    }    
	
}


sub finddepth_gl {

	$errmsg = "";
	$save_local = "";
	
    my ($callback, $level) = @_;

    # Make a listing of files and/or directories.
    my $cwd = cwd;
    opendir(DIR, $cwd) or $errmsg = "Cannot open local directory ($cwd) [cwd].";
    
    my ($item, @list);
    while (defined($item = readdir(DIR))) { push(@list, $item)}
    closedir(DIR);   
    
    foreach $item (@list) {
			
        next if $item =~ /\.\.?$/;
		
			$tot_num_files-- if ($item =~ m/DS_Store/);
			$tot_num_files++;

        my $parent = "";
        my $i;
		
        foreach $i (@path) { ($parent .= $i."/"); }
        if ( -d $item) {
            # It's a directory  call the callback.

			$tot_num_files--;
			
            &$callback($level, 1, $item, $parent);
			
            		#	&writeLog("===$parent$item");
			
            # Recursively crawl the subtree under this directory.
            push(@path, $item);
            my $save_local = cwd;
            chdir("$item") or $errmsg = "Cannot change local directory ($item) [0001].";
	#		if ($errmsg) {	&writeLog("Local Error [0001]: $errmsg Desc: $save_local / $item"); }
			
            finddepth_gl($callback, $level+1);

            # Restore location in local tree.
            chdir($save_local) or $errmsg = "Cannot change local directory ($save_local) [0002].";
	#		if ($errmsg) {	&writeLog("Local Error [0002]: $errmsg Desc: $save_local / $item"); }


            pop(@path);
        } elsif ( -f $item) {
            # It's a file - call the callback.
            &$callback($level, 0, $item, $parent);
        }
		

	
    }



if ($errmsg) {	&writeLog("Error: $errmsg Desc: $save_local / $item"); }

}

###########################
sub writeLog {

$to_write = $_[0];
$time_now = time;

open (LOG, ">>$log_file") || die print"Error writing to log file!";
# print LOG "$time_now \t $to_write\n";
print LOG "$to_write\n";
close (LOG);

}

